// This autogenerated skeleton file illustrates how to build a server.
// You should copy it to another filename to avoid overwriting it.

#include "CloudGatewayService.h"
#include <protocol/TBinaryProtocol.h>
#include <server/TSimpleServer.h>
#include <transport/TServerSocket.h>
#include <transport/TBufferTransports.h>

using namespace ::apache::thrift;
using namespace ::apache::thrift::protocol;
using namespace ::apache::thrift::transport;
using namespace ::apache::thrift::server;

using boost::shared_ptr;

using namespace  ::cg;

class CloudGatewayServiceHandler : virtual public CloudGatewayServiceIf {
 public:
  CloudGatewayServiceHandler() {
    // Your initialization goes here
  }

  void login(std::string& _return, const std::string& userName, const std::string& password, const std::string& queueName) {
    // Your implementation goes here
    printf("login\n");
  }

  void exchange(std::vector<Message> & _return, const std::vector<Message> & src, const int32_t size, const std::string& token) {
    // Your implementation goes here
    printf("exchange\n");
  }

};

int main(int argc, char **argv) {
  int port = 9090;
  shared_ptr<CloudGatewayServiceHandler> handler(new CloudGatewayServiceHandler());
  shared_ptr<TProcessor> processor(new CloudGatewayServiceProcessor(handler));
  shared_ptr<TServerTransport> serverTransport(new TServerSocket(port));
  shared_ptr<TTransportFactory> transportFactory(new TBufferedTransportFactory());
  shared_ptr<TProtocolFactory> protocolFactory(new TBinaryProtocolFactory());

  TSimpleServer server(processor, serverTransport, transportFactory, protocolFactory);
  server.serve();
  return 0;
}

